use serde::Deserialize;

use deckster_shared::state::KeyStyleByStateMap;

#[derive(Debug, Deserialize)]
pub struct SwitchConfig {
    pub name: String,
    #[serde(default)]
    pub style: KeyStyleByStateMap<SwitchState>,
}

#[derive(Debug, Deserialize)]
pub struct ButtonConfig {
    pub name: String,
    #[serde(default)]
    pub style: KeyStyleByStateMap<ButtonState>,
}

#[derive(Debug, Eq, PartialEq, Hash, Deserialize)]
#[serde(rename_all = "kebab-case")]
pub enum SwitchState {
    Unavailable,
    On,
    Off,
}

#[derive(Debug, Eq, PartialEq, Hash, Deserialize)]
#[serde(rename_all = "kebab-case")]
pub enum ButtonState {
    Unavailable,
    Available,
}
